<template>
  <v-row>
    <v-col>
      <price-recap :items="order.items"></price-recap>

      <v-row>
        <v-col>
          <h3>Delivery:</h3>
          <p>{{ deliveryAddress.street }}</p>
          <p>{{ order.deliveryNotes }}</p>
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <h3>Payment method:</h3>
          <p>
            {{ paymentLabel }}
          </p>
        </v-col>
      </v-row>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  props: {
    order: {
      type: Object,
      required: true,
    },
  },
  data: () => {
    return {
      deliveryAddress: {} as any,
      paymentMethod: {} as any,
    }
  },
  computed: {
    paymentLabel(): string {
      if (this.paymentMethod.method === 'cash') return 'Cash on delivery'

      if (this.paymentMethod.card?.number)
        return (
          '**** **** **** ' + this.order.paymentMethod.card.number.slice(-4)
        )

      return ''
    },
  },
  methods: {
    async getAddress() {
      this.deliveryAddress = await this.$axios.$get(
        'http://consumer.localhost:4000/addresses/' + this.order.deliveryAddress
      )
    },
    async getPaymentMethod() {
      this.paymentMethod = await this.$axios.$get(
        'http://consumer.localhost:4000/wallets/' + this.order.paymentMethod
      )
    },
  },
  mounted() {
    this.getAddress()
    this.getPaymentMethod()
  },
})
</script>
